Spoj 9894 Tichu 状压dp

题目链接:点击打开链接

题意:

给定13张各不相同的扑克牌,问最少需要几手打出

每手打出的牌必须符合以下任意标准之一:

1、任意单张

2、相同数字2张

3、相同数字3张

4、相同数字4张

5、相同数字3张+相同数字2张

6、连续5个及5个以上的数字

思路:

状压dp,dp[i]表示选了i的状态的最小牌数

然后要预处理出能一次打出的状态,这样不会t。。

#include <iostream>
#include <algorithm>
#include <cstring>
#include <cmath>
#include <stdio.h>
#include <vector>
using namespace std;
#define inf 1000000
#define maxn (1<<13)
struct node{
    int num;
    char c;
    void put(){
        if(num==14)printf("A");
        else if(2<= num && num <= 9) printf("%d",num);
        else if(num==10)printf("T");
        else if(num == 11)printf("J");
        else if(num==12)printf("Q");
        else printf("K");
        printf("%c",c);
    }
}a[15];
void put(int u){
    for(int i = 0; i < 13 && u; i++){
        if(u&1) {
            a[i].put();
            u>>=1;
            u ? printf(" ") : puts("");
        }
        else u>>=1;
    }
}
int dp[maxn], pre[maxn], all;
int Stack[20], top;
void siz(int x){
    top = 0;
    for(int i = 0; i < 13 && x; i++)
    {
        if(x&1)
            Stack[top++] = i;
        x>>=1;
    }
}
int vis[15];
int ok(int u){
    siz(u);
    memset(vis, 0, sizeof vis);
    int dui = 0, fir= 15, ed = 0;
    for(int i = 0; i < top; i++) {
        if(vis[ a[Stack[i]].num ]==0) {
            dui++;
        }
        vis[ a[Stack[i]].num ] ++;
        fir = min(fir, a[Stack[i]].num);
        ed = max(ed, a[Stack[i]].num);
    }
    if(dui==1 && top<=4)
        return 1;
    if(top == 5 && dui==2) {
        if(vis[fir] ==4 || vis[ed] == 4)return -1;
        return 1;
    }
    if(top>=5 && dui==top && (dui == (ed-fir+1)))
        return 1;
    return -1;
}
vector<int>G;
int dfs(int u){
    if(dp[u]!=-1)
        return dp[u];
    int ans = inf;
    for(int i = 0; i < G.size(); i++) {
        int v = G[i];
        if((v&u)==v) {
            int tmp = dfs(u^v) +1;
            if(ans>tmp)
                pre[u] = u^v, ans = tmp;
        }
    }
    return dp[u] = ans;
}
int main() {
    int T;scanf("%d",&T);
    all = maxn-1;
	while( T--) {
        for(int i = 0; i < 13; i++)
        {
            char s[10]; scanf("%s",s);
            if(s[0]=='A')a[i].num = 14;
            else if('2' <= s[0] &&s[0]<='9')
                a[i].num = s[0]-'0';
            else if(s[0]=='T')
                a[i].num = 10;
            else if(s[0]=='J')
                a[i].num = 11;
            else if(s[0]=='Q')
                a[i].num = 12;
            else a[i].num = 13;
            a[i].c = s[1];
        }
        dp[0] = 0;
        G.clear();
        for(int i = 1; i <= all; i++) {
            dp[i] = ok(i);
            if(dp[i]==1)G.push_back(i);
        }
        memset(pre, -1, sizeof pre);

        cout<<dfs(all)<<endl;

        int u = all;
        while(1) {
            if(pre[u] == -1) {
                put(u);
                break;
            }
            else put( u - pre[u] );
            u = pre[u];
        }
	}
	return 0;
}
/*
99
Aa 2a 3d 4d 5d 6d 7d 8d 9d Ta Ja Qd Kd
2h 3c 4d 5d 6s Th Qc Qs Ad Tc Ts 9c 9d
2h 3h 4h 5h 6d 7s 8h 8d 8c 8s 9c Td Js

2a 2a 3d 4d 5d 6d 7d 8d 9d Ta Ja Qd Kd
2a 2a 2d 2d 5d 6d 7d 8d 9d Ta Ja Qd Kd

2a 2a 4a 4a 6a 6a 8a 8a 9a 9a 9a Qa Ta

2a 2a 4a 4a 6a 6a 8a 8a 9a 9a Qa Qa Ta

2a 2a 3d 4d 5d 6d 7d 8d 9d Ta Ja Qd Kd

2a 3a 4a 5a 7a 8a 9a Ta Qa Ka Aa 2a 2a

2a 2a 2a 2a 7a 8a 9a Ta Qa Ka Aa 3a 4a

*/

Spoj 9894 Tichu 状压dp,布布扣,bubuko.com

时间: 2024-10-24 00:29:03

Spoj 9894 Tichu 状压dp的相关文章

ZOJ3305Get Sauce 状压DP,

状压DP的题目留个纪念,首先题意一开始读错了,搞了好久,然后弄好了,觉得DFS可以,最后超时,修改了很久还是超时,没办法看了一下n的范围,然后觉得状压可以,但是没有直接推出来,就记忆化搜索了一下,可是一直错,莫名奇妙,然后没办法看了一下题解,发现了下面这个比较好的方法,然后按照这个方程去推,然后敲,也是WA了好多把,写的太搓了,没人家的清楚明了,唉~也算是给自己留个纪念,状压一直做的都不太好~唉~还好理解了, 参考了  http://blog.csdn.net/nash142857/articl

poj 2411 Mondriaan&#39;s Dream(状压DP)

Mondriaan's Dream Time Limit: 3000MS   Memory Limit: 65536K Total Submissions: 12232   Accepted: 7142 Description Squares and rectangles fascinated the famous Dutch painter Piet Mondriaan. One night, after producing the drawings in his 'toilet series

(状压dp)uva 10817 Headmaster&#39;s Headache

题目地址 1 #include <bits/stdc++.h> 2 typedef long long ll; 3 using namespace std; 4 const int MAX=1e5+5; 5 const int INF=1e9; 6 int s,m,n; 7 int cost[125]; 8 //char sta[MAX]; 9 string sta; 10 int able[125]; 11 int dp[125][1<<8][1<<8]; 12 in

HDU5816 Hearthstone(状压DP)

题目 Source http://acm.hdu.edu.cn/showproblem.php?pid=5816 Description Hearthstone is an online collectible card game from Blizzard Entertainment. Strategies and luck are the most important factors in this game. When you suffer a desperate situation an

HDU 4336 容斥原理 || 状压DP

状压DP :F(S)=Sum*F(S)+p(x1)*F(S^(1<<x1))+p(x2)*F(S^(1<<x2))...+1; F(S)表示取状态为S的牌的期望次数,Sum表示什么都不取得概率,p(x1)表示的是取x1的概率,最后要加一因为有又多拿了一次.整理一下就可以了. 1 #include <cstdio> 2 const int Maxn=23; 3 double F[1<<Maxn],p[Maxn]; 4 int n; 5 int main() 6

Travel(HDU 4284状压dp)

题意:给n个城市m条路的网图,pp在城市1有一定的钱,想游览这n个城市(包括1),到达一个城市要一定的花费,可以在城市工作赚钱,但前提有工作证(得到有一定的花费),没工作证不能在该城市工作,但可以走,一个城市只能工作一次,问pp是否能游览n个城市回到城市1. 分析:这个题想到杀怪(Survival(ZOJ 2297状压dp) 那个题,也是钱如果小于0就挂了,最后求剩余的最大钱数,先求出最短路和 Hie with the Pie(POJ 3311状压dp) 送披萨那个题相似. #include <

BZOJ 1087: [SCOI2005]互不侵犯King( 状压dp )

简单的状压dp... dp( x , h , s ) 表示当前第 x 行 , 用了 h 个 king , 当前行的状态为 s . 考虑转移 : dp( x , h , s ) = ∑ dp( x - 1 , h - cnt_1( s ) , s' ) ( s and s' 两行不冲突 , cnt_1( s ) 表示 s 状态用了多少个 king ) 我有各种预处理所以 code 的方程和这有点不一样 ------------------------------------------------

BZOJ 1072 排列 状压DP

题意:链接 方法:状压DP? 题解:这题其实没啥好写的,不算很难,推一推就能搞出来. 首先看到这个问题,对于被d整除这个条件,很容易就想到是取余数为0,所以想到可能状态中刚开始含有取余数. 先说我的第一个想法,f[i][j]表示选取i个数且此时的mod为j,这样的思想是第一下蹦出来的,当时想的就是在线来搞最终的答案.不过转瞬即发现,这TM不就是暴力吗魂淡!并没有什么卵用,于是开始想这个状态可不可以做什么优化. 显然第二维的j并不需要太大的优化,暂且先将其搁置一边,来考虑第一维的i怎么优化. 把滚

COdeforces#417D Cunning Gena(状压DP)

A boy named Gena really wants to get to the "Russian Code Cup" finals, or at least get a t-shirt. But the offered problems are too complex, so he made an arrangement with his n friends that they will solve the problems for him. The participants